;Animation
; Created by Freak123
; Last updated: 

Const ANIMATIONOBJECT_MAXANIMATIONS = 20
Type TAnimationObject
	Field image
	
	Field animation.TAnimation[ANIMATIONOBJECT_MAXANIMATIONS]
	Field animationcount
	
	Field activeanimation.TAnimation
	Field actualframe
End Type

Type TAnimation
	Field from, end
	Field parent.TAnimationObject
End Type

Function CreateAnimationObject.TAnimationObject( image )
	Local ao.TAnimationObject=New TAnimationObject
	
	ao\image=image
	
	Return ao
End Function

Function AddAnimation.TAnimation( parent.TAnimationObject, start, End )

If parent\animationcount=ANIMATIONOBJECT_MAXANIMATIONS Then Return Null

Local a.TAnimation=New TAnimation
	
	a\from=start
	a\end=End
	
	a\parent=parent
	a\parent\animation[a\parent\animationcount]=a
	a\parent\animationcount=a\parent\animationcount+1
	
	Return a
End Function

Function StartAnimation( anim.TAnimation )
	
	anim\parent\activeanimation=anim
	anim\parent\actualframe=anim\from
	
End Function

Function StopAnimation( anim.TAnimation )
	
	anim\parent\activeanimation=Null
	
End Function

Function RemoveAnimation( anim.TAnimation )
	
	Local p.TAnimationObject = anim\parent
	Local found=False
	For i=0 To p\animationcount
		Local a.TAnimation=p\animation[i]
		If found=True Then
			p\animation[i-1]=p\animation[i]
		End If
		If a=anim Then found=True
	Next
	p\animationcount=p\animationcount-1
	
End Function


Function RenderAnimation( animobj.TAnimationObject, x, y, update=1 )
	
	If animobj\activeanimation<>Null Then
		DrawImage animobj\image, x, y, animobj\actualframe
		If update Then UpdateAnimation( animobj )
	End If
	
End Function

Function UpdateAnimation( animobj.TAnimationObject )
	
	If animobj\activeanimation<>Null Then 
		animobj\actualframe=animobj\actualframe+1
		If animobj\activeanimation\end<animobj\actualframe Then animobj\activeanimation=Null
	End If
	
End Function


Function IsAnimationActive( animobj.TAnimationObject )
	Return animobj\activeanimation<>Null
End Function

Function GetAnimationLength( anim.TAnimation )
	Return anim\end-anim\from
End Function

;~IDEal Editor Parameters:
;~F#14#1C#2C#33#39#49#52#5C#60
;~C#Blitz3D